<?php
class Formmodel extends Model{

    function Formmodel()
    {
      parent::Model();
      $database = $this->session->userdata('databaseName');
      $this->formdb = $this->load->database($database,TRUE);
    }

    function speciesDDQuery($query)
    {
      $dbQuery = $this->formdb->query($query);
      if($dbQuery->num_rows() > 0)
      {
        foreach($dbQuery->result() as $dbRow)
        {
          $ddArray[$dbRow->Mnemonic] = $dbRow->Mnemonic;
        }
      }
      else
      {
        $ddArray['error'] = 'Insert Species';
      }
      return $ddArray;
    }

    function getCensusList($plotID)
    {
      $this->formdb->distinct();
      $this->formdb->select('PlotCensusNumber');
      $this->formdb->where('PlotID',$plotID);
      $query = $this->formdb->get('Census');
      $censusNumberA['default'] = 'Select';
      foreach($query->result() as $row)
      {
        $censusNumberA[$row->PlotCensusNumber] = $row->PlotCensusNumber;
      }
      return $censusNumberA;
    }

    function getAllQuadratNames($plotID)
    {
      $this->formdb->select('QuadratName');
      $this->formdb->where('PlotID',$plotID);
      $query = $this->formdb->get('Quadrat');
      return $query;
    }

    function getQuadratNames($plotID)
    {
      $this->formdb->select('QuadratName');
      $this->formdb->where('PlotID',$plotID);
      $query = $this->formdb->get('Quadrat');
      if($query->num_rows() > 0)
      {
        foreach($query->result() as $row)
        {
          $array[$row->QuadratName] = $row->QuadratName;
        }
      }
      else
      {
        $array['error'] = 'Quadrat List Empty';
      }
      return $array;
    }

    function getPersonnelNames()
    {
      $this->formdb->select('PersonnelID,FirstName,LastName');
      $this->formdb->from('Personnel');
      $this->formdb->order_by('LastName asc');
      $query = $this->formdb->get();
      if($query->num_rows() > 0)
      {
        foreach($query->result() as $row)
        {
          $array[$row->PersonnelID] = $row->FirstName.' '.$row->LastName;
        }
      }
      else
      {
        $array['error'] = 'Personnel List Empty';
      }
      return $array;
    }

    function getPersonnelNameByID($id)
    {
      $this->formdb->select('FirstName,LastName');
      $this->formdb->from('Personnel');
      $this->formdb->where('PersonnelID',$id);
      $query = $this->formdb->get();

      $row = $query->row();
      $firstName = trim($row->FirstName);
      $lastName = trim($row->LastName);
      $name = $firstName.$lastName;
      return $name;
    }

    function subquadDDQuery($query)
    {
      $dbQuery = $this->formdb->query($query);
      return $dbQuery;
    }

    function olddataextract($lastCensusID,$plotID,$quadratName,$maxX,$maxY,$dimX,$dimY,$orderBy)
    {
      $this->formdb->select('TreeID, StemID, QuadratName, QX, QY,(1 + floor((QX-'.$dimX.'*floor(QX/'.$dimX.'))/'.$maxX.')) AS X, (1 + floor((QY-'.$dimY.'*floor(QY/'.$dimY.'))/'.$maxY.')) AS Y, Mnemonic, Tag, StemTag, ListOfTSM, DBH, HOM');
      $this->formdb->from('ViewFullTable');
      $this->formdb->where('PlotCensusNumber',$lastCensusID);
      $this->formdb->where('PlotID',$plotID);
      $this->formdb->where('QuadratName',$quadratName);
      if($orderBy == 'treetag')
      {
        $this->formdb->order_by('Tag asc, StemTag asc, HOM desc');
      }
      else
      {
        $this->formdb->order_by('X asc, Y asc, TreeID asc, StemID asc, HOM desc');
      }
      $query = $this->formdb->get();
      //$str = $this->formdb->last_query();
      //echo $str;
      //die();
      return $query;
    }

    function getPlotNameByID($plotID)
    {
      $this->formdb->select('PlotName');
      $this->formdb->where('PlotID',$plotID);
      $query = $this->formdb->get('Site');
      $row = $query->row();
      $plotName = $row->PlotName;
      return $plotName;
    }

    function getPlotName()
    {
      //$this->db5->distinct();
      $this->formdb->select('PlotID,PlotName');
      $query = $this->formdb->get('Site');
      $plotNameA['default'] = 'Select';
      foreach($query->result() as $row)
      {
        $plotNameA[$row->PlotID] = $row->PlotName;
      }
      return $plotNameA;
    }
}